package com.beamofsoul.bip.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.beamofsoul.bip.management.util.Constants;

@Controller
public class HomeController {
	
	@RequestMapping(value = { "/", "/index" }, method = RequestMethod.GET)
	public String index(HttpServletRequest request, HttpServletResponse response, Map<String, Object> map) {
		return "index";
	}
	
	@RequestMapping(value = "/admin/adminIndex", method = RequestMethod.GET)
	public ModelAndView adminIndex(HttpServletRequest request, HttpServletResponse response, HttpSession session) {
		return new ModelAndView("admin_index");
	}
	
	@RequestMapping(value = "/admin/adminIndexContent", method = RequestMethod.GET)
	public ModelAndView adminIndexContent() {
		return new ModelAndView("/fragment/admin_content");
	}

	@RequestMapping(value = "/login", method = RequestMethod.GET)
	public String login(HttpSession session, Map<String, Object> map) {
		if (session.getAttribute(Constants.CURRENT_USER) != null)
			return "redirect:/index";
		return "login";
	}

	@RequestMapping(value = "/logout", method = RequestMethod.GET)
	public String logout(HttpSession session, Map<String, Object> map) {
		session.invalidate();
		return "login";
	}

	@RequestMapping(value = "/expired", method = RequestMethod.GET)
	public String expired(Map<String, Object> map) {
		map.put("expired", "该账号已经在其他地方重新登录");
		return "login";
	}
	
	@RequestMapping(value = "/anonymous", method = RequestMethod.GET)
	public String anonymousLogin() {
		return "admin_index";
	}
	
//	@RequestMapping(value = "/admin/systemLog")
//	public String systemLog() {
//		return "/system_log/admin_system_log_list";
//	}
}
